"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Problem_1 = require("../models/Problem");
var isProblem_1 = require("../utils/isProblem");
var clauseFromAlts_1 = require("../utils/clauseFromAlts");
function andWalker(clause, walkFn) {
    var exprs = clause.opts.conformedExprs.map(clauseFromAlts_1.default);
    return {
        trailblaze: andTrailblaze,
        reconstruct: andReconstruct,
    };
    function andTrailblaze(data, walkOpts) {
        var r = data;
        var conforms = [];
        var problems = [];
        for (var i = 0; i < exprs.length; i += 1) {
            var currData = (i === 0) ? data : conforms[i - 1];
            r = walkFn(exprs[i], currData, walkOpts);
            if (isProblem_1.default(r)) {
                problems.push(r);
                break;
            }
            else {
                var conformedR = walkFn(exprs[i], r, Object.assign({}, walkOpts, { phase: 'reconstruct' }));
                conforms.push(conformedR);
            }
        }
        if (problems.length === 0) {
            return { conforms: conforms };
        }
        else {
            return new Problem_1.default(data, exprs, problems, 'One or more expressions failed AND test');
        }
    }
    function andReconstruct(_a) {
        var conforms = _a.conforms;
        //TODO: implement propagated conform. Perhaps as an option propagateConform
        // or as a separate clause construct such as "propagate"
        return conforms[exprs.length - 1];
    }
}
exports.default = andWalker;
//# sourceMappingURL=andWalker.js.map